package LCSS; # String::LCSS on CPAN 

use strict;
use Exporter;

our @ISA    = qw(Exporter);
our @EXPORT = qw( lcss );

sub lcss {
    my ( $a, $b ) = @_;
    my ( @x, @y );
    my ( $maxLength, $maxXi, $maxXk, $switch ) = ( 0, 0, 0, 0 );
    my $returnString;

    my $m = length($a);
    my $n = length($b);

    if ( $m > $n ) {
        ( $m, $n ) = ( $n, $m );
        ( $a, $b ) = ( $b, $a );
        $switch = 1;
    }

    @x = split( //, $a );
    @y = split( //, $b );

    # declare variables outside of loops for a hair more speed.
    my ( $i, $ii, $j, $k, $length, $xi, $xj );

    for ( $k = 0; $k < $n; $k++ ) {

        # abort if the remainder of the string to check is
        # less than the common substring length already found
        last if ( $maxLength >= ( $m - $k ) );

        ( $xi, $length ) = ( 0, 0 );

        for ( $i = 0; $i < $m; $i++ ) {
            $j      = $k;
            $length = 0;
            for ( $ii = 0; $ii < ( $m - $i ); $ii++ ) {
                if ( $x[ $i + $ii ] eq $y[$j] ) {
                    $xi = $i + $ii unless ($length);
                    $xj = $j       unless ($length);
                    $length++;
                    $j++;
                }
                elsif ($length) {
                    if ( $length > $maxLength ) {
                        $maxLength = $length;
                        $maxXi     = $xi;
                        $maxXk     = $xj;
                    }
                    last;
                }
            }
        }
    }

    if ( $maxLength > 1 ) {
        for ( $i = $maxXi; $i < $maxXi + $maxLength; $i++ ) {
            $returnString .= $x[$i];
        }
        ( $maxXi, $maxXk ) = ( $maxXk, $maxXi ) if ($switch);
    }

    (wantarray) ? ( $returnString, $maxXi, $maxXk ) : $returnString;
}

1;

__END__
