from checkbox.plugin import Plugin


class CertifyMessage(Plugin):

    def register(self, manager):
        super(CertifyMessage, self).register(manager)

        self._schemas = {}

        self._manager.reactor.call_on("message-(send|receive)", self.message_check, -100)
        for (rt, rh) in [
             ("gather-schema", self.gather_schema),
             ("message-receive", self.message_receive)]:
            self._manager.reactor.call_on(rt, rh)

    def gather_schema(self, schema):
        self._schemas[schema.type] = schema

    def message_check(self, message):
        assert "type" in message

        if message["type"] not in self._schemas:
            raise Exception("Unsupported schema")

        # Only check that the value can be coerced
        self._schemas[message["type"]].coerce(message)

    def message_receive(self, message):
        self._manager.reactor.fire(message["type"], message)


factory = CertifyMessage
